// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosbag2_interfaces:srv/Seek.idl
// generated code does not contain a copyright notice
#include "rosbag2_interfaces/srv/detail/seek__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `time`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
rosbag2_interfaces__srv__Seek_Request__init(rosbag2_interfaces__srv__Seek_Request * msg)
{
  if (!msg) {
    return false;
  }
  // time
  if (!builtin_interfaces__msg__Time__init(&msg->time)) {
    rosbag2_interfaces__srv__Seek_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosbag2_interfaces__srv__Seek_Request__fini(rosbag2_interfaces__srv__Seek_Request * msg)
{
  if (!msg) {
    return;
  }
  // time
  builtin_interfaces__msg__Time__fini(&msg->time);
}

bool
rosbag2_interfaces__srv__Seek_Request__are_equal(const rosbag2_interfaces__srv__Seek_Request * lhs, const rosbag2_interfaces__srv__Seek_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // time
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->time), &(rhs->time)))
  {
    return false;
  }
  return true;
}

bool
rosbag2_interfaces__srv__Seek_Request__copy(
  const rosbag2_interfaces__srv__Seek_Request * input,
  rosbag2_interfaces__srv__Seek_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // time
  if (!builtin_interfaces__msg__Time__copy(
      &(input->time), &(output->time)))
  {
    return false;
  }
  return true;
}

rosbag2_interfaces__srv__Seek_Request *
rosbag2_interfaces__srv__Seek_Request__create()
{
  rosbag2_interfaces__srv__Seek_Request * msg = (rosbag2_interfaces__srv__Seek_Request *)malloc(sizeof(rosbag2_interfaces__srv__Seek_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosbag2_interfaces__srv__Seek_Request));
  bool success = rosbag2_interfaces__srv__Seek_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rosbag2_interfaces__srv__Seek_Request__destroy(rosbag2_interfaces__srv__Seek_Request * msg)
{
  if (msg) {
    rosbag2_interfaces__srv__Seek_Request__fini(msg);
  }
  free(msg);
}


bool
rosbag2_interfaces__srv__Seek_Request__Sequence__init(rosbag2_interfaces__srv__Seek_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rosbag2_interfaces__srv__Seek_Request * data = NULL;
  if (size) {
    data = (rosbag2_interfaces__srv__Seek_Request *)calloc(size, sizeof(rosbag2_interfaces__srv__Seek_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosbag2_interfaces__srv__Seek_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosbag2_interfaces__srv__Seek_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosbag2_interfaces__srv__Seek_Request__Sequence__fini(rosbag2_interfaces__srv__Seek_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosbag2_interfaces__srv__Seek_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosbag2_interfaces__srv__Seek_Request__Sequence *
rosbag2_interfaces__srv__Seek_Request__Sequence__create(size_t size)
{
  rosbag2_interfaces__srv__Seek_Request__Sequence * array = (rosbag2_interfaces__srv__Seek_Request__Sequence *)malloc(sizeof(rosbag2_interfaces__srv__Seek_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rosbag2_interfaces__srv__Seek_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rosbag2_interfaces__srv__Seek_Request__Sequence__destroy(rosbag2_interfaces__srv__Seek_Request__Sequence * array)
{
  if (array) {
    rosbag2_interfaces__srv__Seek_Request__Sequence__fini(array);
  }
  free(array);
}

bool
rosbag2_interfaces__srv__Seek_Request__Sequence__are_equal(const rosbag2_interfaces__srv__Seek_Request__Sequence * lhs, const rosbag2_interfaces__srv__Seek_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosbag2_interfaces__srv__Seek_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosbag2_interfaces__srv__Seek_Request__Sequence__copy(
  const rosbag2_interfaces__srv__Seek_Request__Sequence * input,
  rosbag2_interfaces__srv__Seek_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosbag2_interfaces__srv__Seek_Request);
    rosbag2_interfaces__srv__Seek_Request * data =
      (rosbag2_interfaces__srv__Seek_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosbag2_interfaces__srv__Seek_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosbag2_interfaces__srv__Seek_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosbag2_interfaces__srv__Seek_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
rosbag2_interfaces__srv__Seek_Response__init(rosbag2_interfaces__srv__Seek_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
rosbag2_interfaces__srv__Seek_Response__fini(rosbag2_interfaces__srv__Seek_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
}

bool
rosbag2_interfaces__srv__Seek_Response__are_equal(const rosbag2_interfaces__srv__Seek_Response * lhs, const rosbag2_interfaces__srv__Seek_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  return true;
}

bool
rosbag2_interfaces__srv__Seek_Response__copy(
  const rosbag2_interfaces__srv__Seek_Response * input,
  rosbag2_interfaces__srv__Seek_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  return true;
}

rosbag2_interfaces__srv__Seek_Response *
rosbag2_interfaces__srv__Seek_Response__create()
{
  rosbag2_interfaces__srv__Seek_Response * msg = (rosbag2_interfaces__srv__Seek_Response *)malloc(sizeof(rosbag2_interfaces__srv__Seek_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosbag2_interfaces__srv__Seek_Response));
  bool success = rosbag2_interfaces__srv__Seek_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rosbag2_interfaces__srv__Seek_Response__destroy(rosbag2_interfaces__srv__Seek_Response * msg)
{
  if (msg) {
    rosbag2_interfaces__srv__Seek_Response__fini(msg);
  }
  free(msg);
}


bool
rosbag2_interfaces__srv__Seek_Response__Sequence__init(rosbag2_interfaces__srv__Seek_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rosbag2_interfaces__srv__Seek_Response * data = NULL;
  if (size) {
    data = (rosbag2_interfaces__srv__Seek_Response *)calloc(size, sizeof(rosbag2_interfaces__srv__Seek_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosbag2_interfaces__srv__Seek_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosbag2_interfaces__srv__Seek_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosbag2_interfaces__srv__Seek_Response__Sequence__fini(rosbag2_interfaces__srv__Seek_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosbag2_interfaces__srv__Seek_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosbag2_interfaces__srv__Seek_Response__Sequence *
rosbag2_interfaces__srv__Seek_Response__Sequence__create(size_t size)
{
  rosbag2_interfaces__srv__Seek_Response__Sequence * array = (rosbag2_interfaces__srv__Seek_Response__Sequence *)malloc(sizeof(rosbag2_interfaces__srv__Seek_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rosbag2_interfaces__srv__Seek_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rosbag2_interfaces__srv__Seek_Response__Sequence__destroy(rosbag2_interfaces__srv__Seek_Response__Sequence * array)
{
  if (array) {
    rosbag2_interfaces__srv__Seek_Response__Sequence__fini(array);
  }
  free(array);
}

bool
rosbag2_interfaces__srv__Seek_Response__Sequence__are_equal(const rosbag2_interfaces__srv__Seek_Response__Sequence * lhs, const rosbag2_interfaces__srv__Seek_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosbag2_interfaces__srv__Seek_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosbag2_interfaces__srv__Seek_Response__Sequence__copy(
  const rosbag2_interfaces__srv__Seek_Response__Sequence * input,
  rosbag2_interfaces__srv__Seek_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosbag2_interfaces__srv__Seek_Response);
    rosbag2_interfaces__srv__Seek_Response * data =
      (rosbag2_interfaces__srv__Seek_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosbag2_interfaces__srv__Seek_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosbag2_interfaces__srv__Seek_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosbag2_interfaces__srv__Seek_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
